package pxbase;

import java.io.*;
import java.sql.*;
import pxbase.BaseArray;
import xml64.Xml64;

public class pxbase{
    static int ELEMENT_TYPE = 1;
    static int ATTR_TYPE = 2;
    static int TEXT_TYPE = 3;
    static int DTD_TYPE = 4;
    static int PI_TYPE = 5;
    static int COMMENT_TYPE = 6;
    static int XML_TYPE = 7;
    static int NAME_TYPE = 8;
    
    private Connection con;    // The connection to the database
    private Statement  st;    // Our statement to run queries with
    
    private String table = "";     //e[u
    private int db;                //f[^x[X敪
    
    private String xml_buff = "";
    private String enc= "SJIS";
	private xml64.Xml64 xml64;
    private BaseArray idArray = new BaseArray();

    public pxbase(String dbname,Connection db_con,String db_table)
    throws ClassNotFoundException, FileNotFoundException, IOException, SQLException ,Exception{
 		xml64 = new xml64.Xml64(1);
		con = db_con;
        table = db_table;
        if(dbname.equalsIgnoreCase("PostgreSQL"))
            db = 1;
        else if(dbname.equalsIgnoreCase("MySQL"))
            db = 2;
        else
            db = 3;
        st = con.createStatement();
		String xml = get_xml(1);
		get_encode(xml);
    }
    public ResultSet do_query(String sql,String func) throws Exception{
        ResultSet rs=null;
        String tmp = sql.substring(0,6);
        try{
            if(tmp.equalsIgnoreCase("select")){
                rs = st.executeQuery(sql);
            }else{
                st.executeUpdate(sql);
            }
        }catch(Exception e){
            String error ="\nG[II\n"+func+":do_query: "+sql+"̎sɎs܂\n";
            try{
                 con.rollback();
                 if(db == 2){
                    sql = "unlock tables";
                    st.executeUpdate(sql);
                }
            }catch(Exception e2){
                error += "\nG[II\n"+func+":do_query: rollback ̎sɎs܂\n";
                try{
                    if(db == 2){
                        sql = "unlock tables";
                        st.executeUpdate(sql);
                    }
                }catch(Exception e3){
                    error += "\nG[II\n"+func+":do_query: "+sql+"̎sɎs܂\n";
                    die(error);
                }
                die(error);
            }
            die(error);
        }
        return rs;
    }
    public void begin() throws Exception{
        if(db == 1){
          String sql = "begin";
          do_query(sql,"begin");
        }else if(db == 2){
   	      con.setAutoCommit(false);
        }
                   
    }
    public void commit() throws Exception {
        if(db == 1){
          String sql = "commit";
          do_query(sql,"commit");
        }else if(db == 2){
          con.commit();
        }
    }
    public void lock()  throws Exception{
        if(db == 1){
            String sql = "lock table "+table+" in share row exclusive mode";
            do_query(sql,"lock");
        }else if(db == 2){
            String sql = "lock tables "+table+" write";
            do_query(sql,"lock");
        }
    }
    public void unlock() throws Exception {
        String sql = "unlock tables";
        do_query(sql,"lock");
    }
    public int num_rows(ResultSet rs) throws Exception{
        int num=0;
        while(rs.next()){
            num++;
        }
        return num;
    }
/*    public String result_String(ResultSet rs,int row,String field) throws Exception{
        rs.absolute(row);
        String data = rs.getString(field);
        return data;
     }
    public String result_String(ResultSet rs,int row,int field) throws Exception{
        rs.absolute(row);
        String data = rs.getString(field);
        return data;
     }
    public int result_int(ResultSet rs,int row,String field) throws Exception{
        rs.absolute(row);
        int data = rs.getInt(field);
        return data;
     }
    public int result_int(ResultSet rs,int row,int field) throws Exception{
        rs.absolute(row);
        int data = rs.getInt(field);
        return data;
     }
 */
    public void make_table(int flg) throws Exception{
        String sql="";
        if(flg == 1){
            sql = "select * from "+table;
            try{
                ResultSet rs = st.executeQuery(sql);
                rs.close();
                sql = "drop table "+table;
                do_query(sql,"make_table");
            }catch(Exception e){
            }
        }
        sql = "create table "+table+" (id integer NOT NULL,type smallint,name text,value text,parent integer,pos integer,ns text,PRIMARY KEY(id))";
        //        system.out.print(sql);
        do_query(sql,"make_table");
    }
    public int get_root() throws Exception{
        return 0;
    }
    public int get_doc_root() throws Exception{
        String sql = "select id from "+table+" where parent=0 and type="+ELEMENT_TYPE;
        ResultSet rs = do_query(sql,"get_doc_root");
        int id=0;
        if(!rs.next())
            die("\nG[II\nget_doc_root:hLg[g͗L܂B");
        id = rs.getInt(1);
        rs.close();
        return id;
    }
    public boolean is_exist(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id;
        ResultSet rs = do_query(sql,"");
        if(!rs.next()){
            rs.close();
            return false;
        }else{
            rs.close();
            return true;
        }
    }
    public boolean is_element(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
        ResultSet rs = do_query(sql,"is_element");
        if(rs.next()){
            rs.close();
            return true;
        }else{
            rs.close();
            return false;
        }
    }
    public boolean is_text(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+TEXT_TYPE;
        ResultSet rs = do_query(sql,"is_text");
        if(rs.next()){
            rs.close();
            return true;
        }else{
            rs.close();
            return false;
        }
    }
    public boolean is_attrib(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ATTR_TYPE;
        ResultSet rs = do_query(sql,"is_attrib");
        if(rs.next()){
            rs.close();
            return true;
        }else{
            rs.close();
            return false;
        }
    }
    public boolean is_comment(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+COMMENT_TYPE;
        ResultSet rs = do_query(sql,"is_comment");
        if(rs.next()){
            rs.close();
            return true;
        }else{
            rs.close();
            return false;
        }
    }
    public boolean is_dtd(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+DTD_TYPE;
        ResultSet rs = do_query(sql,"is_dtd");
        if(rs.next()){
            rs.close();
            return true;
        }else{
            rs.close();
            return false;
        }
    }
    public boolean is_pi(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+PI_TYPE;
        ResultSet rs = do_query(sql,"is_pi");
        if(rs.next()){
            rs.close();
            return true;
        }else{
            rs.close();
            return false;
        }
    }
    public boolean is_xml(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+XML_TYPE;
        ResultSet rs = do_query(sql,"is_xml");
        if(rs.next()){
            rs.close();
            return true;
        }else{
            rs.close();
            return false;
        }
    }
    public BaseArray get_elements(int id,String path) throws Exception{
        if(path.equals("")){
            die("\nG[II\nget_elements:pXłBid="+id+" path="+path);
        }
//		path = xml64.text_encode(path,"SJIS");
        int index=0;
        BaseArray path_array = new BaseArray();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add_string(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add_string(path);
        }
        path = path_array.get_string(0);
        BaseArray nodeList = get_child_elements(id,path);
        if(nodeList.isEmpty())
            die("get_elements :" + path +"m[hԍpXُłB" );
        id = nodeList.get_int(0);
        if(path_array.size() > 1){
            for(int i=1;i<path_array.size();i++){
                path = (String)path_array.get(i);
                nodeList = get_child_elements(id,path);
                if(nodeList.isEmpty())
                    die("get_elements :" + path +"m[hԍpXُłB" );
                id = nodeList.get_int(0);
            }
        }
        return nodeList;
    }
    public BaseArray get_elements(int id,String path,String ns) throws Exception{
        if(path.equals("")){
            die("\nG[II\nget_elements:pXłBid="+id+" path="+path);
        }
//		path = xml64.text_encode(path,"SJIS");
//		ns = xml64.text_encode(ns,"SJIS");
        int index=0;
        BaseArray path_array = new BaseArray();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add_string(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add_string(path);
        }
        path = path_array.get_string(0);
        int size = path_array.size();
        BaseArray nodeList;
        if(size == 1){
            nodeList = get_child_elements(id,path,ns);
        }else{
            nodeList = get_child_elements(id,path);
        }
        if(nodeList.isEmpty())
            die("get_elements :" + path +"m[hԍpXl[Xy[XُłB" );
        id = nodeList.get_int(0);
        if(size > 1){
            for(int i=1;i<size;i++){
                path = (String)path_array.get(i);
                if(i == size-1){
                    nodeList = get_child_elements(id,path,ns);
                }else{
                    nodeList = get_child_elements(id,path);
                }
                if(nodeList.isEmpty())
                    die("get_elements :" + path +"m[hԍpXl[Xy[XُłB" );
                id = nodeList.get_int(0);
            }
        }
        return nodeList;
    }
    public int get_first_element(int id,String path) throws Exception{
        if(path.equals("")){
            die("\nG[II\nget_first_element:pXłBid="+id+" path="+path);
        }
//		path = xml64.text_encode(path,enc);
        int index=0;
        BaseArray path_array = new BaseArray();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add_string(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add_string(path);
        }
        path = path_array.get_string(0);
        BaseArray nodeList = get_child_elements(id,path);
        if(nodeList.isEmpty())
            die("get_first_element :" + path +"m[hԍpXُłB" );
        id = nodeList.get_int(0);
        if(path_array.size() > 1){
            for(int i=1;i<path_array.size();i++){
                path = path_array.get_string(i);
                nodeList = get_child_elements(id,path);
                if(nodeList.isEmpty())
                    die("get_first_elements :" + path +"m[hԍpXُłB" );
                id = nodeList.get_int(0);
            }
        }
        return id;
    }
    public int get_first_element(int id,String path,String ns) throws Exception{
        if(path.equals("")){
            die("\nG[II\nget_first_element:pXłBid="+id+" path="+path);
        }
//		path = xml64.text_encode(path,"SJIS");
//		ns = xml64.text_encode(ns,"SJIS");
        int index=0;
        BaseArray path_array = new BaseArray();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add_string(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add_string(path);
        }
        int size = path_array.size();
        path = path_array.get_string(0);
        BaseArray nodeList;
        if(size == 1){
            nodeList = get_child_elements(id,path,ns);
        }else{
            nodeList = get_child_elements(id,path);
        }
        if(nodeList.isEmpty())
            die("get_first_element :" + path +"m[hԍpXl[Xy[XُłB" );
        id = nodeList.get_int(0);
        if(size > 1){
            for(int i=1;i<size;i++){
                path = path_array.get_string(i);
                if(i == size-1){
                    nodeList = get_child_elements(id,path,ns);
                }else{
                   nodeList = get_child_elements(id,path);
                }
                if(nodeList.isEmpty())
                    die("get_first_elements :" + path +"m[hԍpXl[Xy[XُłB" );
                id = nodeList.get_int(0);
            }
        }
        return id;
    }
    public BaseArray get_child_elements(int id,String child_name) throws Exception{
        if(child_name.equals("")){
            die("\nG[II\nget_child_elements:pXłBid="+id+" child_name="+child_name);
        }
		child_name = xml64.text_encode(child_name,enc);
		child_name = addslashes(child_name);
        String sql;
        if(child_name.equals("*")){
            sql = "select id from "+table+" where parent="+id+" and type="+ELEMENT_TYPE+" order by pos";
        }else{
            sql = "select id from "+table+" where parent="+id+" and name='"+child_name+"' and type="+ELEMENT_TYPE+" order by pos";
        }
        ResultSet rs = do_query(sql,"get_child_elements");
        BaseArray node_array = new BaseArray();
        while(rs.next()){
            node_array.add_int(rs.getInt(1));
        }
        rs.close();
        return node_array;
    }
    public BaseArray get_child_elements(int id,String child_name,String ns) throws Exception{
        if(child_name.equals("")){
            die("\nG[II\nget_child_elements:pXłBid="+id+" child_name="+child_name);
        }
		child_name = xml64.text_encode(child_name,enc);
		ns = xml64.text_encode(ns,enc);
 		child_name = addslashes(child_name);
		ns = addslashes(ns);
       String sql;
        if(child_name.equals("*")){
            sql = "select id from "+table+" where parent="+id+" and ns='"+ns+"' and type="+ELEMENT_TYPE+" order by pos";
        }else{
            sql = "select id from "+table+" where parent="+id+" and name='"+child_name+"' and ns='"+ns+"' and type="+ELEMENT_TYPE+" order by pos";
        }
        ResultSet rs = do_query(sql,"get_child_elements");
        BaseArray node_array = new BaseArray();
        while(rs.next()){
            node_array.add_int(rs.getInt(1));
        }
        rs.close();
        return node_array;
    }
    public BaseArray get_comments(int parent) throws Exception{
        String sql = "select id from "+table+" where parent="+parent+" and type="+COMMENT_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"get_comments");
        BaseArray node_array = new BaseArray();
        while(rs.next()){
            node_array.add_int(rs.getInt(1));
        }
        rs.close();
        return node_array;
    }
    public int get_parent(int id) throws Exception{
        String sql = "select parent from "+table+" where id="+id;
        ResultSet rs = do_query(sql,"get_parent");
        int parent=0;
        if(!rs.next())
            die("\nG[II\nget_parent:m[hԍُłBid="+id);
        parent = rs.getInt(1);
        rs.close();
        return parent;
    }
    public String get_text(int id) throws Exception{
        String sql = "select value from "+table+" where id="+id+" and type="+TEXT_TYPE;
        ResultSet rs = do_query(sql,"get_text");
        if(!rs.next())
            die("\nG[II\nget_text:m[hԍُłBid="+id);
        String value = rs.getString(1);
        rs.close();
		value = xml64.text_decode(value,enc);
        return value;
    }
    public BaseArray get_text_nodes(int id) throws Exception{
        String sql = "select id from "+table+" where parent="+id+" and type="+TEXT_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"get_text_nodes");
        if(!rs.next())
            die("\nG[II\nget_text_nodes:m[hԍُ킩eLXgL܂Bid="+id);
        BaseArray node_array = new BaseArray();
        node_array.add_int(rs.getInt(1));
        while(rs.next()){
            node_array.add_int(rs.getInt(1));
        }
        rs.close();
        return node_array;
    }
    public String get_value(int id) throws Exception{
        String sql = "select value from "+table+" where parent="+id+" and type="+TEXT_TYPE+" order by pos";
        ResultSet rs2 = do_query(sql,"get_value");
        String value="";
        while(rs2.next()){
            String tmp = rs2.getString(1);
			tmp = xml64.text_decode(tmp,enc);
            if(tmp != ""){
                value = value + tmp.trim() + "\n";
            }
        }
        rs2.close();
        return value;
    }
    public String get_child_value(int id,String child_name) throws Exception{
        if(child_name.equals("")){
            die("\nG[II\nget_child_value:qvfłBid="+id+" child_name="+child_name);
        }
		child_name = xml64.text_encode(child_name,enc);
 		child_name = addslashes(child_name);
        String sql = "select id from "+table+" where parent="+id+" and name='"+child_name+"' and type="+ELEMENT_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"get_child_value");
        String value="";
        BaseArray node_array = new BaseArray();
        while(rs.next()){
            node_array.add_int(rs.getInt(1));
        }
        rs.close();
		int size = node_array.size();
		for(int i=0;i<size;i++){
			id = node_array.get_int(i);
			value = value + get_value(id);
        }
        if(size == 0){
			child_name = xml64.text_decode(child_name,enc);
            die("\nG[II\nget_child_value:m[hԍ܂͎qvfُłBid="+id+" child_name="+child_name+"enc="+enc);
        }
		return value;
    }
    public String get_child_value(int id,String child_name,String ns) throws Exception{
        if(child_name.equals("")){
            die("\nG[II\nget_child_value:qvfłBid="+id+" child_name="+child_name);
        }
		child_name = xml64.text_encode(child_name,enc);
 		child_name = addslashes(child_name);
		ns = xml64.text_encode(ns,enc);
  		ns = addslashes(ns);
        String sql = "select id from "+table+" where parent="+id+" and name='"+child_name+"' and ns='"+ns+"' and type="+ELEMENT_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"get_child_value");
        String value="";
        BaseArray node_array = new BaseArray();
        while(rs.next()){
            node_array.add_int(rs.getInt(1));
        }
        rs.close();
		int size = node_array.size();
		for(int i=0;i<size;i++){
			id = node_array.get_int(i);
			value = value + get_value(id);
        }
        if(size == 0){
			child_name = xml64.text_decode(child_name,enc);
            die("\nG[II\nget_child_value:m[hԍ܂͎qvfُłBid="+id+" child_name="+child_name);
        }
        return value;
    }
    public String get_comment(int id) throws Exception{
        String sql = "select value from "+table+" where id="+id+" and type="+COMMENT_TYPE;
        ResultSet rs = do_query(sql,"get_comment");
        if(!rs.next())
            die("\nG[II\nget_comment:m[hԍُłBid="+id);
        String value = rs.getString(1);
        rs.close();
		value = xml64.text_decode(value,enc);
        return value;
    }
    public String get_xml(int id) throws Exception{
        String sql = "select value from "+table+" where id="+id+" and type="+XML_TYPE;
        ResultSet rs = do_query(sql,"get_xml");
        if(!rs.next())
            die("\nG[II\nget_xml:m[hԍُłBid="+id);
        String value = rs.getString(1);
        rs.close();
		value = xml64.text_decode(value,enc);
        return value;
    }
    public String get_dtd(int id) throws Exception{
        String sql = "select value from "+table+" where id="+id+" and type="+DTD_TYPE;
        ResultSet rs = do_query(sql,"get_dtd");
        if(!rs.next())
            die("\nG[II\nget_dtd:m[hԍُłBid="+id);
        String value = rs.getString(1);
        rs.close();
		value = xml64.text_decode(value,enc);
        return value;
    }
    public String get_pi(int id) throws Exception{
        String sql = "select name,value from "+table+" where id="+id+" and type="+PI_TYPE;
        ResultSet rs  = do_query(sql,"get_pi");
        if(!rs.next())
            die("\nG[II\nget_pi:m[hԍُłBid="+id);
        String target = rs.getString(1);
        if(target != null){
            target = target.trim();
        }else{
            target = "";
        }
        String data = rs.getString(2);
        if(data != null){
            data = data.trim();
        }else{
            data = "";
        }
		target = xml64.text_decode(target,enc);
		data = xml64.text_decode(data,enc);
        String pi = "<?"+target+"\n\t"+data+"\n?>\n";
        rs.close();
        return pi;
    }
    public String get_ns(int id) throws Exception{
        String sql = "select ns from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
        ResultSet rs  = do_query(sql,"get_ns");
        if(!rs.next())
            die("\nG[II\nget_ns:m[hԍُłBid="+id);
        String ns = rs.getString(1);
		ns = xml64.text_decode(ns,enc);
        if(ns != null){
            ns = ns.trim();
        }else{
            ns = "";
        }
        return ns;
    }
    public String get_uri(String ns,int id) throws Exception{
        String sql;
        ResultSet rs;
        if(ns.equals("")){
            while(true){
                sql = "select value from "+table+" where parent="+id+" and name='default' and type="+NAME_TYPE;
                rs  = do_query(sql,"get_uri");
                if(!rs.next()){
                   if(id == 0)
                        die("\nG[II\nget_uri:m[hԍl[Xy[XُłBid="+id+" ns="+ns);
                    sql = "select parent from "+table+" where id="+id;
                    rs  = do_query(sql,"get_uri");
                    if(!rs.next()){
                        die("\nG[II\nget_uri:m[hԍl[Xy[XُłBid="+id+" ns="+ns);
                    }else{
                        id = rs.getInt(1);
                    }
                }else{
                    break;
                }
            }
         }else{
			ns = xml64.text_encode(ns,enc);
  			ns = addslashes(ns);
            sql = "select value from "+table+" where name='"+ns+"' and type="+NAME_TYPE;
            rs  = do_query(sql,"get_uri");
            if(!rs.next())
                die("\nG[II\nget_uri:m[hԍl[Xy[XُłBid="+id+" ns="+ns);
        }
        String uri = rs.getString(1);
		uri = xml64.text_decode(uri,enc);
        if(uri != null){
            uri = uri.trim();
        }else{
            uri = "";
        }
        return uri;
    }
    public String get_node_name(int id) throws Exception{
        String sql = "select name from "+table+" where id="+id;
        ResultSet rs = do_query(sql,"get_node_name");
        if(!rs.next())
            die("\nG[II\nget_node_name:m[hԍُłBid="+id);
        String name = rs.getString(1);
        rs.close();
		name = xml64.text_decode(name,enc);
        return name;
    }
    public int get_node_type(int id) throws Exception{
        String sql = "select type from "+table+" where id="+id;
        ResultSet rs = do_query(sql,"get_node_value");
        if(rs == null)
            die("\nG[II\nget_node_type:m[hԍُłBid="+id);
        rs.next();
        int type = rs.getInt(1);
        rs.close();
        return type;
    }
    public String get_node_value(int id) throws Exception{
        String sql = "select value from "+table+" where id="+id;
        ResultSet rs = do_query(sql,"get_node_value");
        if(!rs.next())
            die("\nG[II\nget_node_value:m[hԍُłBid="+id);
        String value = rs.getString(1);
        rs.close();
		value = xml64.text_decode(value,enc);
        return value;
    }
    public int get_node_pos(int id) throws Exception{
        String sql = "select pos from "+table+" where id="+id;
        ResultSet rs = do_query(sql,"get_node_pos");
        if(!rs.next())
            die("\nG[II\nget_node_pos:m[hԍُłBid="+id);
        int pos = rs.getInt(1);
        rs.close();
        return pos;
    }
    public int get_node_parent(int id) throws Exception{
        String sql = "select parent from "+table+" where id="+id;
        ResultSet rs = do_query(sql,"get_node_parent");
        if(!rs.next())
            die("\nG[II\nget_node_value:m[hԍُłBid="+id);
        int parent = rs.getInt(1);
        rs.close();
        return parent;
    }
    public BaseArray get_nodes(int type) throws Exception{
        String sql = "select id from table where type="+type;
        ResultSet rs = do_query(sql,"get_nodes");
        BaseArray node_array = new BaseArray();
        while(rs.next()){
            node_array.add_int(rs.getInt(1));
        }
        rs.close();
        return node_array;
    }
    public String get_attrib(int id,String attrib_name) throws Exception{
        if(attrib_name.equals("")){
            die("\nG[II\nget_attrib:łBid="+id+" attrib_name="+attrib_name);
        }
        attrib_name = addslashes(attrib_name);
		attrib_name = xml64.text_encode(attrib_name,enc);
        String sql = "select value from "+table+" where parent="+id+" and name='"+attrib_name+"' and type="+ATTR_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"get_attrib");
        String value="";
        if(rs.next()){
            value = rs.getString(1);
            if(value == null){
                value = "";
            }
        }
        rs.close();
		value = xml64.text_decode(value,enc);
        return value;
    }
    public BaseArray get_attribs(int id) throws Exception{
        String sql = "select name,value from "+table+" where parent="+id+" and type="+ATTR_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"get_attribs");
        BaseArray node_array = new BaseArray();
        while(rs.next()){
            String tmp = rs.getString(1);
            if(tmp == null) tmp = "";
			tmp = xml64.text_decode(tmp,enc);
            node_array.add_string(tmp);
            tmp = rs.getString(2);
            if(tmp == null) tmp="";
			tmp = xml64.text_decode(tmp,enc);
            node_array.add_string(tmp);
        }
        rs.close();
        return node_array;
    }
    public int del_child(int child) throws Exception{
        String sql = "select pos,parent,type from "+table+" where id="+child+" for update";
        ResultSet rs = do_query(sql,"del_child");
        if(!rs.next())
            die("\nG[II\ndel_child:m[hԍُłBid=child");
        int pos = rs.getInt(1);
        int parent = rs.getInt(2);
        int type = rs.getInt(3);
        if(type == ATTR_TYPE){
            sql = "select * from "+table+" where parent="+parent+" and type="+type+" and pos>"+pos+" for update";
            rs = do_query(sql,"del_child");
            sql = "update "+table+" set pos=pos-1 where parent="+parent+" and type="+type+" and pos>"+pos;
            do_query(sql,"del_child");
        }else{
            sql = "select * from "+table+" where parent="+parent+" and type!="+ATTR_TYPE+" and pos>"+pos+" for update";
            rs = do_query(sql,"del_child");
            sql = "update "+table+" set pos=pos-1 where parent="+parent+" and type!="+ATTR_TYPE+" and pos>"+pos;
            do_query(sql,"del_child");
        }
        sql = "update "+table+" set parent=null , pos=1 where id="+child;
        do_query(sql,"del_child");
        rs.close();
        return child;
    }
    public int del_child_element(int id,String child_name) throws Exception{
        if(child_name.equals("")){
            die("\nG[II\ndel_child_element:qvfłBid="+id+" child_name="+child_name);
        }
        child_name = addslashes(child_name);
		child_name = xml64.text_encode(child_name,enc);
        String sql = "select id from "+table+" where parent="+id+" and name='"+child_name+"' and type="+ELEMENT_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"del_child_element");
		child_name = xml64.text_decode(child_name,enc);
		if(!rs.next())
            die("\nG[II\ndel_child_element:m[hԍ܂͎qvfُłBid="+id+" child_name="+child_name);
        int child = rs.getInt(1);
        del_child(child);
        rs.close();
        return child;
    }
    public int del_child_element(int id,String child_name,String ns) throws Exception{
        if(child_name.equals("")){
            die("\nG[II\ndel_child_element:qvfłBid="+id+" child_name="+child_name);
        }
        child_name = addslashes(child_name);
 		child_name = xml64.text_encode(child_name,enc);
        ns = addslashes(ns);
 		ns = xml64.text_encode(ns,enc);
		String sql = "select id from "+table+" where parent="+id+" and name='"+child_name+"' and ns='"+ns+"' and type="+ELEMENT_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"del_child_element");
		child_name = xml64.text_decode(child_name,enc);
        if(!rs.next())
            die("\nG[II\ndel_child_element:m[hԍ܂͎qvf܂̓l[Xy[XُłBid="+id+" child_name="+child_name+" ns="+ns);
        int child = rs.getInt(1);
        del_child(child);
        rs.close();
        return child;
    }
    public int del_attrib(int id,String attrib) throws Exception{
        if(attrib.equals("")){
            die("\nG[II\ndel_attrib:łBid="+id+" attrib_name="+attrib);
        }
        attrib = addslashes(attrib);
 		attrib = xml64.text_encode(attrib,enc);
        String sql = "select id from "+table+" where parent="+id+" and name='"+attrib+"' and type="+ATTR_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"del_attrib");
		attrib = xml64.text_decode(attrib,enc);
        if(!rs.next())
            die("\nG[II\ndel_attrib:m[hԍ܂ُ͑łBid="+id+" attrib="+attrib);
        int child = rs.getInt(1);
        del_child(child);
        rs.close();
        return child;
    }
    public int del_text(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+TEXT_TYPE+" for update";
        ResultSet rs = do_query(sql,"del_text");
        if(!rs.next())
            die("\nG[II\ndel_text:m[hԍُłBid="+id);
        del_child(id);
        rs.close();
        return id;
    }
    public int del_comment(int id) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+COMMENT_TYPE+" for update";
        ResultSet rs = do_query(sql,"del_comment");
        if(!rs.next())
            die("\nG[II\ndel_comment:m[hԍُłBid="+id);
        del_child(id);
        rs.close();
        return id;
    }
    public void del_element_value(int id) throws Exception{
        String sql = "select id from "+table+" where parent="+id+" and type="+TEXT_TYPE+" order by pos for update";
        ResultSet rs = do_query(sql,"del_element_value");
		int[] temp = new int[1024];
        if(!rs.next())
            die("\nG[II\ndel_element_value:m[hԍُ܂̓eLXg܂Bid="+id);
		int i=1;
		temp[0] = rs.getInt(1); 
        while(rs.next()){
            temp[i++] = rs.getInt(1);
        }
		for(int j=0;j<i;j++){
			int text = temp[j];
        	sql = "delete from "+table+" where id="+text;
        	do_query(sql,"del_element_value");
		}
        rs.close();
    }
    public void del_node(int id,int flg) throws Exception{
        String sql;
        ResultSet rs;
        if(flg == 1){
            sql = "select id from "+table+" where parent="+id+" order by pos";
            rs = do_query(sql,"del_node");
            while(rs.next()){
                int child = rs.getInt(1);
                del_node(child,1);
            }
        }
        sql = "select id from "+table+" where id="+id+" for update";
        rs = do_query(sql,"del_node");
        if(!rs.next())
            die("\nG[II\ndel_node:m[hԍُłBid="+id);
        sql = "delete from "+table+" where id="+id;
        do_query(sql,"del_node");
        rs.close();
    }
    public void add_child(int id,int child) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
        ResultSet rs = do_query(sql,"add_child");
        if(!rs.next())
            die("\nG[II\nadd_child:m[hԍُłBid="+id);
        sql = "select id from "+table+" where id="+child+"  and type="+ELEMENT_TYPE+" for update";
        rs = do_query(sql,"add_child");
        if(!rs.next())
            die("\nG[II\nadd_child:m[hԍُłBchild="+child);
        sql = "select pos from "+table+" where parent="+id+" and type!="+ATTR_TYPE+" order by pos DESC for update";
        rs = do_query(sql,"add_child");
        int pos;
        if(!rs.next()){
            pos = 1;
        }else{
            pos = rs.getInt(1) + 1;
        }
        sql = "update "+table+" set pos="+pos+" , parent="+id+" where id="+child;
        do_query(sql,"add_child");
        rs.close();
    }
    public void add_text(int id,int text) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
        ResultSet rs = do_query(sql,"add_text");
        if(!rs.next())
            die("\nG[II\nadd_text:m[hԍُłBid="+id);
        sql = "select id from "+table+" where id="+text+"  and type="+TEXT_TYPE+" for update";
        rs = do_query(sql,"add_text");
        if(!rs.next())
            die("\nG[II\nadd_text:eLXgm[hԍُłBtext="+text);
        sql = "select pos from "+table+" where parent="+id+" and type!="+ATTR_TYPE+" order by pos DESC for update";
        rs = do_query(sql,"add_text");
        int pos;
        if(!rs.next()){
            pos = 1;
        }else{
            pos = rs.getInt(1) + 1;
        }
        sql = "update "+table+" set pos="+pos+" , parent="+id+" where id="+text;
        do_query(sql,"add_text");
        rs.close();
    }
    public void add_attrib(int id,int attrib) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
        ResultSet rs = do_query(sql,"add_attrib");
        if(!rs.next())
            die("\nG[II\nadd_attrib:m[hԍُłBid="+id);
        sql = "select id from "+table+" where id="+attrib+"  and type="+ATTR_TYPE+" for update";
        rs = do_query(sql,"add_attrib");
        if(!rs.next())
            die("\nG[II\nadd_attrib:m[hԍُłBattrib="+attrib);
        sql = "select pos from "+table+" where parent="+id+" and type="+ATTR_TYPE+" order by pos DESC for update";
        rs = do_query(sql,"add_attrib");
        int pos;
        if(!rs.next()){
            pos = 1;
        }else{
            pos = rs.getInt(1) + 1;
        }
        sql = "update "+table+" set pos="+pos+" , parent="+id+" where id="+attrib;
        do_query(sql,"add_attrib");
        int parent = 0-attrib;
        sql = "select id from "+table+" where parent='"+parent+"' and type='"+NAME_TYPE+"' for update";
        rs = do_query(sql,"add_attrib");
		int[] temp = new int[1024];
		int i=0;
        while(rs.next()){
            temp[i++] = rs.getInt(1);
		}
		for(int j=0;j<i;j++){
			int id2 = temp[j];
            sql = "update "+table+" set parent='"+id+"' where id='"+id2+"'";
            do_query(sql,"add_attrib");
        }
        rs.close();
    }
    public void add_comment(int id,int comment) throws Exception{
        String sql;
        ResultSet rs;
        if(id != 0){
            sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
            rs = do_query(sql,"add_comment");
            if(!rs.next())
                die("\nG[II\nadd_comment:m[hԍُłBid="+id);
        }
        sql = "select id from "+table+" where id="+comment+" and type="+COMMENT_TYPE+" for update";
        rs = do_query(sql,"add_comment");
        if(!rs.next())
            die("\nG[II\nadd_comment:Rgm[hԍُłBcomment="+comment);
        sql = "select pos from "+table+" where parent="+id+" and type!="+ATTR_TYPE+" order by pos DESC for update";
        rs = do_query(sql,"add_comment");
        int pos;
        if(!rs.next()){
            pos = 1;
        }else{
            pos = rs.getInt(1) + 1;
        }
        sql = "update "+table+" set pos="+pos+" , parent="+id+" where id="+comment;
        do_query(sql,"add_comment");
        rs.close();
    }
    public void insert_child(int id,int child,int ref) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
        ResultSet rs = do_query(sql,"insert_child");
        if(!rs.next())
            die("\nG[II\ninsert_child:m[hԍُłBid="+id);
        sql = "select id from "+table+" where id="+child+"  and type="+ELEMENT_TYPE+" for update";
        rs = do_query(sql,"insert_child");
        if(!rs.next())
            die("\nG[II\ninsert_child:qm[hԍُłBchild="+child);
        sql = "select pos from "+table+" where id="+ref+" for update";
        rs = do_query(sql,"insert_child");
        if(!rs.next())
            die("\nG[II\ninsert_child:t@Xm[hԍُłBref="+ref);
        int pos = rs.getInt(1);
        sql = "update "+table+" set pos=pos+1 where parent="+id+" and pos>="+pos+" and type!="+ATTR_TYPE;
        do_query(sql,"insert_child");
        sql = "update "+table+" set pos="+pos+" , parent="+id+" where id="+child;
        do_query(sql,"insert_child");
        rs.close();
    }
    public void insert_text(int id,int child,int ref) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
        ResultSet rs = do_query(sql,"insert_text");
        if(!rs.next())
            die("\nG[II\ninsert_text:m[hԍُłBid="+id);
        sql = "select id from "+table+" where id="+child+"  and type="+TEXT_TYPE+" for update";
        rs = do_query(sql,"insert_text");
        if(!rs.next())
            die("\nG[II\ninsert_text:eLXgm[hԍُłBchild="+child);
        sql = "select pos from "+table+" where id="+ref+" for update";
        rs = do_query(sql,"insert_text");
        if(!rs.next())
            die("\nG[II\ninsert_text:t@Xm[hԍُłBref="+ref);
        int pos = rs.getInt(1);
        sql = "update "+table+" set pos=pos+1 where parent="+id+" and pos>="+pos+" and type!="+ATTR_TYPE;
        do_query(sql,"insert_text");
        sql = "update "+table+" set pos="+pos+" , parent="+id+" where id="+child;
        do_query(sql,"insert_text");
        rs.close();
    }
    public void insert_attrib(int id,int child,int ref) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
        ResultSet rs = do_query(sql,"insert_attrib");
        if(!rs.next())
            die("\nG[II\ninsert_attrib:m[hԍُłBid="+id);
        sql = "select id from "+table+" where id="+child+"  and type="+ATTR_TYPE+" for update";
        rs = do_query(sql,"insert_attrib");
        if(!rs.next())
            die("\nG[II\ninsert_attrib:m[hԍُłBchild="+child);
        sql = "select pos from "+table+" where id="+ref+"  and type="+ATTR_TYPE+" for update";
        rs = do_query(sql,"insert_attrib");
        if(!rs.next())
            die("\nG[II\ninsert_attrib:t@Xm[hԍُłBref="+ref);
        int pos = rs.getInt(1);
        sql = "update "+table+" set pos=pos+1 where parent="+id+" and pos>="+pos+" and type="+ATTR_TYPE;
        do_query(sql,"insert_attrib");
        sql = "update "+table+" set pos="+pos+" , parent="+id+" where id="+child;
        do_query(sql,"insert_attrib");
        int parent = 0-child;
        sql = "select id from "+table+" where parent='"+parent+"' and type='"+NAME_TYPE+"' for update";
        rs = do_query(sql,"insert_attrib");
        while(rs.next()){
            int id2 = rs.getInt(1);
            sql = "update "+table+" set parent='"+id+"' where id='"+id2+"'";
            do_query(sql,"insert_attrib");
        }
       rs.close();
    }
    public void insert_comment(int id,int child,int ref) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE;
        ResultSet rs = do_query(sql,"insert_comment");
        if(!rs.next())
            die("\nG[II\ninsert_comment:m[hԍُłBid="+id);
        sql = "select id from "+table+" where id="+child+"  and type="+COMMENT_TYPE+" for update";
        rs = do_query(sql,"insert_comment");
        if(!rs.next())
            die("\nG[II\ninsert_comment:qm[hԍُłBchild="+child);
        sql = "select pos from "+table+" where id="+ref+" for update";
        rs = do_query(sql,"insert_comment");
        if(!rs.next())
            die("\nG[II\ninsert_comment:t@Xm[hԍُłBref="+ref);
        int pos = rs.getInt(1);
        sql = "update "+table+" set pos=pos+1 where parent="+id+" and pos>="+pos+" and type!="+ATTR_TYPE;
        do_query(sql,"insert_comment");
        sql = "update "+table+" set pos="+pos+" , parent="+id+" where id="+child;
        do_query(sql,"insert_comment");
        rs.close();
    }
    public int make_element(String name) throws Exception{
        if(name.equals("")){
            die("\nG[II\nmake_element:vfłBname="+name);
        }
        String sql = "select id from "+table+" order by id desc for update";
        ResultSet rs = do_query(sql,"make_element");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        name = addslashes(name);
		name = xml64.text_encode(name,enc);
        String ns = new String("");
        sql = "insert into "+table+" (id,type,name,pos,ns) values("+id+","+ELEMENT_TYPE+",'"+name+"',1,'"+ns+"')";
        do_query(sql,"make_element");
        rs.close();
        return id;
    }
    public int make_element(String name,String ns) throws Exception{
        if(name.equals("")){
            die("\nG[II\nmake_element:vfłBname="+name);
        }
        String sql = "select id from "+table+" order by id desc for update";
        ResultSet rs = do_query(sql,"make_element");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        name = addslashes(name);
        ns = addslashes(ns);
		name = xml64.text_encode(name,enc);
		ns = xml64.text_encode(ns,enc);
        sql = "insert into "+table+" (id,type,name,pos,ns) values("+id+","+ELEMENT_TYPE+",'"+name+"',1,'"+ns+"')";
        do_query(sql,"make_element");
        rs.close();
        return id;
    }
    public int make_text(String value) throws Exception{
        if(value.equals("")){
            die("\nG[II\nmake_text:eLXg̒lłBvalue="+value);
        }
        String sql = "select id from "+table+" order by id DESC for update";
        ResultSet rs = do_query(sql,"make_text");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        value = addslashes(value);
		value = xml64.text_encode(value,enc);
        sql = "insert into "+table+" (id,type,value,pos) values("+id+","+TEXT_TYPE+",'"+value+"',1)";
        do_query(sql,"make_text");
        rs.close();
        return id;
    }
    public int make_attrib(String attrib_name,String attrib_value) throws Exception{
        if(attrib_name.equals("")){
            die("\nG[II\nmake_attrib:łBattrib_name="+attrib_name+" attrib_value="+attrib_value);
        }
        String sql = "select id from "+table+" order by id DESC for update";
        ResultSet rs = do_query(sql,"make_attrib");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        sql = "select pos from "+table+" where type="+NAME_TYPE+" and name='default' order by pos DESC";
        rs = do_query(sql,"make_attrib");
        int nsd_index;
        if(!rs.next()){
            nsd_index = 0;
        }else{
            nsd_index = rs.getInt(1) + 1;
        }
        int parent = 0-id;
        attrib_name = addslashes(attrib_name);
        attrib_value = addslashes(attrib_value);
		attrib_name = xml64.text_encode(attrib_name,enc);
		attrib_value = xml64.text_encode(attrib_value,enc);
        sql = "insert into "+table+" (id,type,name,value,pos) values("+id+","+ATTR_TYPE+",'"+attrib_name+"','"+attrib_value+"',1)";
        do_query(sql,"make_attrib");

        //l[Xy[X̏
        int pos = attrib_name.indexOf("xmlns:");
        if(pos != -1){
            attrib_name = replace("xmlns:","",attrib_name);
            int id2 = id+1;
            sql = "insert into "+table+" (id,type,name,value,parent,pos) values("+id2+","+NAME_TYPE+",'"+attrib_name+"','"+attrib_value+"',"+parent+",0)";
            try{
                do_query(sql,"save_attrib_sub");
            }catch (Exception e){
                die(e.getMessage());
            }
        }
        pos = attrib_name.indexOf("xmlns");
        if(pos != -1){
            int id2 = id+1;
            sql = "insert into "+table+" (id,type,name,value,parent,pos) values("+id2+","+NAME_TYPE+",'default','"+attrib_value+"',"+parent+","+nsd_index+")";
            try{
                do_query(sql,"save_attrib_sub");
            }catch (Exception e){
                die(e.getMessage());
            }
            nsd_index++;
		}
		rs.close();
		return id;
    }
    public int make_comment(String comment) throws Exception{
        if(comment.equals("")){
            die("\nG[II\nmake_comment:RgłBcomment="+comment);
        }
        String sql = "select id from "+table+" order by id DESC for update";
        ResultSet rs = do_query(sql,"make_comment");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        comment = addslashes(comment);
		comment = xml64.text_encode(comment,enc);
        sql = "insert into "+table+" (id,type,value,pos) values("+id+","+COMMENT_TYPE+",'"+comment+"',1)";
        do_query(sql,"make_comment");
        rs.close();
        return id;
    }
    public int make_doc_root(String node_name) throws Exception{
        if(node_name.equals("")){
            die("\nG[II\nmake_doc_root:vfłBnode_name="+node_name);
        }
        String sql = "select id from "+table+" where type="+ELEMENT_TYPE+" and parent=0";
        ResultSet rs = do_query(sql,"make_doc_root");
        if(rs.next())
            die("\nG[II\nmake_doc_root: hLg[g͕쐬ł܂B");
        sql = "select id from "+table+" order by id DESC for update";
        rs = do_query(sql,"make_doc_root");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        node_name = addslashes(node_name);
		node_name = xml64.text_encode(node_name,enc);
        String ns = new String("");
        sql = "insert into "+table+" (id,type,name,parent,pos,ns) values("+id+","+ELEMENT_TYPE+",'"+node_name+"',0,1,'"+ns+"')";
        do_query(sql,"make_doc_root");
        try{
            rs.close();
        }catch(Exception e){
            die(e.toString());
        }
        return id;
    }
    public int make_doc_root(String node_name,String ns) throws Exception{
        if(node_name.equals("")){
            die("\nG[II\nmake_doc_root:vfłBnode_name="+node_name);
        }
        String sql = "select id from "+table+" where type="+ELEMENT_TYPE+" and parent=0";
        ResultSet rs = do_query(sql,"make_doc_root");
        if(rs.next())
            die("\nG[II\nmake_doc_root: hLg[g͕쐬ł܂B");
        sql = "select id from "+table+" order by id DESC for update";
        rs = do_query(sql,"make_doc_root");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        node_name = addslashes(node_name);
        ns = addslashes(ns);
		node_name = xml64.text_encode(node_name,enc);
		ns = xml64.text_encode(ns,enc);
        sql = "insert into "+table+" (id,type,name,parent,pos,ns) values("+id+","+ELEMENT_TYPE+",'"+node_name+"',0,1,'"+ns+"')";
        do_query(sql,"make_doc_root");
        try{
            rs.close();
        }catch(Exception e){
            die(e.toString());
        }
        return id;
    }
    public int make_dtd(String dtd) throws Exception{
        if(dtd.equals("")){
            die("\nG[II\nmake_dtd:DTDłBdtd="+dtd);
        }
        String sql = "select id from "+table+" where type="+DTD_TYPE+" and parent=0";
        ResultSet rs = do_query(sql,"make_dtd");
        if(rs.next())
            die("\nG[II\nmake_dtd: DTD͕쐬ł܂B");
        sql = "select id from "+table+" order by id DESC for update";
        rs = do_query(sql,"make_dtd");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        dtd = addslashes(dtd);
		dtd = xml64.text_encode(dtd,enc);
        sql = "insert into "+table+" (id,type,value,parent,pos) values("+id+","+DTD_TYPE+",'"+dtd+"',0,1)";
        do_query(sql,"make_dtd");
        rs.close();
        return id;
    }
    public int make_xml(String xml) throws Exception{
        if(xml.equals("")){
            die("\nG[II\nmake_xml:XML錾łBxml="+xml);
        }
        String sql = "select id from "+table+" where type="+XML_TYPE+" and parent=0";
        ResultSet rs = do_query(sql,"make_xml");
        if(rs.next())
            die("\nG[II\nmake_xml: XML錾͕쐬ł܂B");
        sql = "select id from "+table+" order by id DESC for update";
        rs = do_query(sql,"make_xml");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        xml = addslashes(xml);
		xml = xml64.text_encode(xml,enc);
        sql = "insert into "+table+" (id,type,value,parent,pos) values("+id+","+XML_TYPE+",'"+xml+"',0,1)";
        do_query(sql,"make_xml");
        rs.close();
        return id;
    }
    public int make_pi(String target,String data) throws Exception{
        if(target.equals("")){
            die("\nG[II\nmake_pi:targetłBtarget="+target+" data="+data);
        }
        if(data.equals("")){
            die("\nG[II\nmake_pi:datałBtarget="+target+" data="+data);
        }
        String sql = "select max(pos) from "+table+" where type="+PI_TYPE+" and parent=0";
        ResultSet rs = do_query(sql,"make_pi");
        int pos;
        if(!rs.next())
            pos = 1;
        else{
            pos = rs.getInt(1) +1;
        }
        sql = "select id from "+table+" order by id DESC for update";
        rs = do_query(sql,"make_pi");
        int id;
        if(!rs.next()){
            id = 1;
        }else{
            id = rs.getInt(1) + 1;
        }
        target = addslashes(target);
        data = addslashes(data);
		target = xml64.text_encode(target,enc);
		data = xml64.text_encode(data,enc);
        sql = "insert into "+table+" (id,type,name,value,parent,pos) values("+id+","+PI_TYPE+",'"+target+"','"+data+"',0,"+pos+")";
        do_query(sql,"make_pi");
        rs.close();
        return id;
    }
    public void set_value(int id,String value) throws Exception{
        if(value.equals("")){
            die("\nG[II\nset_value:lłBvalue="+value);
        }
        String sql = "select id from "+table+" where parent="+id+" and type="+TEXT_TYPE+" order by pos for update";
        ResultSet rs = do_query(sql,"set_value");
        if(!rs.next()){
            int text = make_text(value);
            add_text(id,text);
        }else{
            value = addslashes(value);
			value = xml64.text_encode(value,enc);
            int id2 = rs.getInt(1);
            sql = "update "+table+" set value='"+value+"' where id="+id2;
            do_query(sql,"set_value");
            while(rs.next()){
                id2 = rs.getInt(1);
                del_node(id2,0);
            }
            sql = "select id from "+table+" where parent="+id+" and type!="+ATTR_TYPE+" order by pos for update";
            rs = do_query(sql,"set_value");
            int i=0;
            rs.next();
            while(rs.next()){
                i++;
                id2 = rs.getInt(1);
                sql = "update "+table+" set pos="+i+" where id="+id2;
                do_query(sql,"set_value");
            }
        }
        rs.close();
    }
    public void set_text(int id,String text) throws Exception{
        if(text.equals("")){
            die("\nG[II\nset_text:lłBtext="+text);
        }
        String sql = "select id from "+table+" where id="+id+" and type="+TEXT_TYPE+" for update";
        ResultSet rs = do_query(sql,"set_text");
        if(!rs.next())
            die("\nG[II\nset_text:m[hԍُłBid="+id);
        text = addslashes(text);
		text = xml64.text_encode(text,enc);
        sql = "update "+table+" set value='"+text+"' where id="+id;
        do_query(sql,"set_text");
        rs.close();
    }
    public void set_attrib(int id,String attrib_name,String attrib_value) throws Exception{
        if(attrib_name.equals("")){
            die("\nG[II\nset_attrib:łBid="+id+" attrib_name="+attrib_name+" attrib_value="+attrib_value);
        }
        String attrib_name2 = addslashes(attrib_name);
		attrib_name2 = xml64.text_encode(attrib_name2,enc);
        String sql = "select id from "+table+" where parent="+id+" and name='"+attrib_name2+"' and type="+ATTR_TYPE+" for update";
        ResultSet rs = do_query(sql,"set_attrib");
        if(!rs.next()){
            int attrib = make_attrib(attrib_name,attrib_value);
            add_attrib(id,attrib);
        }else{
            id = rs.getInt(1);
            attrib_value = addslashes(attrib_value);
			attrib_value = xml64.text_encode(attrib_value,enc);
            sql = "update "+table+" set value="+attrib_value+" where id="+id;
            do_query(sql,"set_attrib");
        }
        rs.close();
    }
    public void set_node_name(int id,String name) throws Exception{
        if(name.equals("")){
            die("\nG[II\nset_node_name:vfłBid="+id+" name="+name);
        }
        String sql = "select id from "+table+" where id="+id+" for update ";
        ResultSet rs = do_query(sql,"set_node_name");
        if(!rs.next())
            die("\nG[II\nset_node_name:m[hԍُłBid="+id);
        name = addslashes(name);
		name = xml64.text_encode(name,enc);
        sql = "update "+table+" set name='"+name+"' where id="+id;
        do_query(sql,"set_node_name");
        rs.close();
    }
    public void set_ns(int id,String ns) throws Exception{
        String sql = "select id from "+table+" where id="+id+" and type="+ELEMENT_TYPE+" for update ";
        ResultSet rs = do_query(sql,"set_ns");
        if(!rs.next())
            die("\nG[II\nset_ns:m[hԍُłBid="+id);
        ns = addslashes(ns);
		ns = xml64.text_encode(ns,enc);
        sql = "update "+table+" set ns='"+ns+"' where id="+id;
        do_query(sql,"set_ns");
        rs.close();
    }
    public void set_uri(String ns,String uri) throws Exception{
        if(uri.equals("")){
            die("\nG[II\nset_uri:URIłBns="+ns+" URI="+uri);
        }
        if(ns.equals("")){
            die("\nG[II\nset_uri:l[Xy[XłBns="+ns+" URI="+uri);
        }
        ns = addslashes(ns);
		ns = xml64.text_encode(ns,enc);
        String sql = "select id from "+table+" where name='"+ns+"' and type="+NAME_TYPE+" for update ";
        ResultSet rs = do_query(sql,"set_uri");
        if(!rs.next())
            die("\nG[II\nset_uri:l[Xy[XُłBns="+ns);
        uri = addslashes(uri);
		uri = xml64.text_encode(uri,enc);
        sql = "update "+table+" set value='"+uri+"' where name='"+ns+"' and type="+NAME_TYPE;
        do_query(sql,"set_uri");

        ns = "xmlns:"+ns;
        ns = addslashes(ns);
		ns = xml64.text_encode(ns,enc);
        sql = "select id from "+table+" where name='"+ns+"' and type="+ATTR_TYPE+" for update ";
        rs = do_query(sql,"set_ns");
        if(!rs.next())
            die("\nG[II\nset_uri:܂Battr_name="+ns);
        sql = "update "+table+" set value='"+uri+"' where name='"+ns+"' and type="+ATTR_TYPE;
        do_query(sql,"set_uri");

        rs.close();
    }
    
    public void write_attribs(int id,FileWriter fp) throws Exception{
        BaseArray node_array = get_attribs(id);
        if(!node_array.isEmpty()){
            if(!(node_array.get_string(0)).equals("")){
                int num = node_array.size();
                for(int i=0;i<num;i++){
                    String name = node_array.get_string(i++);
                    String value = node_array.get_string(i);
  					name = xml64.text_decode(name,enc);
 					value = xml64.text_decode(value,enc);
                   if(fp == null){
                        xml_buff = xml_buff + " "+name+"=\""+value+"\"";
                    }else{
                        fwrite(fp," "+name+"=\""+value+"\"");
                    }
                }
            }
        }
    }
    public void write_comment(int id,FileWriter fp) throws Exception{
        String sql = "select value from "+table+" where id="+id+" and type="+COMMENT_TYPE;
        ResultSet rs = do_query(sql,"write_comment");
        rs.next();
        String value = rs.getString(1);
		value = xml64.text_decode(value,enc);
        if(value != null){
            value = value.trim();
        }else{
            value = "";
        }
        if(fp == null){
            xml_buff = xml_buff + value+"\n";
        }else{
            fwrite(fp,value+"\n");
        }
        rs.close();
    }
    public void write_node(int id,FileWriter fp,int level) throws Exception{
        String sql = "select name,type,ns from "+table+" where id="+id;
        ResultSet rs = do_query(sql,"write_node");
        rs.next();
        String name = rs.getString(1);
		name = xml64.text_decode(name,enc);
        if(name == null) name = "";
        int type = rs.getInt(2);
        String ns = rs.getString(3);
		ns = xml64.text_decode(ns,enc);
        if(ns != null){
            if(!ns.equals("")){
                name = ns +":" + name;
            }
        }
        if(fp == null){
            for(int i=0;i<level;i++){
                xml_buff = xml_buff + "\t";
            }
        }else{
            for(int i=0;i<level;i++){
                fwrite(fp,"\t");
            }
        }
        if(type == COMMENT_TYPE){
            write_comment(id,fp);
        }else{
            sql = "select id from "+table+" where parent="+id+" and (type="+ELEMENT_TYPE+" or type="+COMMENT_TYPE+") order by pos";
            rs = do_query(sql,"write_node");
            int num = num_rows(rs);
            sql = "select value from "+table+" where parent="+id+" and type="+TEXT_TYPE+" order by pos";
            ResultSet rs2 = do_query(sql,"write_node");
            if(name != null){
                name = name.trim();
            }else{
                name = "";
            }
            String value = "";
            while(rs2.next()){
                String tmp = rs2.getString(1);
		 		tmp = xml64.text_decode(tmp,enc);
            	if(tmp != null){
                    value = value + tmp.trim() + "\n";
                }
            }
            rs2.close();
            BaseArray text_array = split("\n",value);
            if(fp == null){
                xml_buff = xml_buff + "<"+name;
            }else{
                fwrite(fp,"<"+name);
            }
            write_attribs(id,fp);
            int num2 = text_array.size();
            if(num == 0){
                if(num2 ==0){
                    if(fp == null){
                        xml_buff = xml_buff + "/>\n";
                    }else{
                        fwrite(fp,"/>\n");
                    }
                }else if(num2 == 1){
                    value = (String)text_array.get(0);
                    if(value == null) value ="";
                    if(fp == null){
                        xml_buff = xml_buff + ">"+value+"</"+name+">\n";
                    }else{
                        fwrite(fp,">"+value+"</"+name+">\n");
                    }
                }else{
                    value = "";
                    for(int i=0;i<num2;i++){
                        String tmp = text_array.get_string(i);
                        if(!tmp.equals("")&&(tmp != null)){
                            for(int j=0;j<=level;j++){
                                value = value + "\t";
                            }
                            value = value + tmp + "\n";
                        }
                    }
                    if(fp == null){
                        xml_buff = xml_buff + ">\n";
                        xml_buff = xml_buff + value;
                        for(int i=0;i<level;i++){
                            xml_buff = xml_buff + "\t";
                        }
                        xml_buff = xml_buff + "</"+name+">\n";
                    }else{
                        fwrite(fp,">\n");
                        fwrite(fp,value);
                        for(int i=0;i<level;i++){
                            fwrite(fp,"\t");
                        }
                        fwrite(fp,"</"+name+">\n");
                    }
                }
            }else{
                if(fp == null){
                    xml_buff = xml_buff + ">\n";
                }else{
                    fwrite(fp,">\n");
                }
                sql = "select id,type,value from "+table+" where parent="+id+" and (type="+ELEMENT_TYPE+" or type="+COMMENT_TYPE+" or type="+TEXT_TYPE+") order by pos";
                rs = do_query(sql,"write_node");
                BaseArray id_array = new BaseArray();
                BaseArray type_array = new BaseArray();
                BaseArray value_array = new BaseArray();        
                while(rs.next()){
                    type = rs.getInt(2);
                    int child = rs.getInt(1);
                    if(type == TEXT_TYPE){
                        value = rs.getString(3);
		 		 		value = xml64.text_decode(value,enc);
                    	if(value != null){
                            value = value.trim();
                        }else{
                            value = "";
                        }
                    }else{
                        value = "";
                    }
                    id_array.add_int(child);
                    type_array.add_int(type);
                    value_array.add_string(value);
                }
                num = id_array.size();
                for(int i=0;i<num;i++){
                    type = type_array.get_int(i);
                    int child = id_array.get_int(i);
                    value = value_array.get_string(i);
                    
                    if((type == ELEMENT_TYPE)||(type == COMMENT_TYPE)){
                        write_node(child,fp,level+1);
                    }else{
                        text_array = split("\n",value);
                        num2 = text_array.size();
                        value = "";
                        for(int j=0;j<num2;j++){
                            if(!((String)text_array.get(j)).equals("")){
                                for(int k=0;k<=level;k++){
                                    value = value + "\t";
                                }
                                value = value + text_array.get_string(j) + "\n";
                            }
                        }
                        if(fp == null){
                            xml_buff = xml_buff + value;
                        }else{
                            fwrite(fp,value);
                        }
                    }
                }
                if(fp == null){
                    for(int i=0;i<level;i++){
                        xml_buff = xml_buff + "\t";
                    }
                    xml_buff = xml_buff + "</"+name+">\n";
                }else{
                    for(int i=0;i<level;i++){
                        fwrite(fp,"\t");
                    }
                    fwrite(fp,"</"+name+">\n");
                }
            }
        }
        rs.close();
    }
    public BaseArray split(String pat,String text) throws Exception{
        BaseArray text_array = new BaseArray();
        int index = 0;
        while((index=text.indexOf(pat)) != -1){
            if(index != 0){
                text_array.add_string(text.substring(0,index));
            }
            text = text.substring(index+pat.length());
        }
        if(!text.equals("")&&(text != null)){
            text_array.add_string(text);
        }
        return text_array;
    }
    public void write_document(FileWriter fp,int flg) throws Exception{
        String sql = "select value from "+table+" where type="+XML_TYPE+" order by pos";
        ResultSet rs = do_query(sql,"write_document");
        rs.next();
        String xml_block = rs.getString(1);
		xml_block = xml64.text_decode(xml_block,enc);
		xml_block = stripslashes(xml_block);
        if(xml_block != null){
            xml_block = xml_block.trim();
        }else{
            xml_block = "";
        }
        if(xml_block.equals("")){
            if(fp == null){
                xml_buff = xml_buff + "<?xml version=\"1.0\" encoding=\"Shift_JIS\" ?>\n";
            }else{
                fwrite(fp,"<?xml version=\"1.0\" encoding=\"Shift_JIS\" ?>\n");
            }
        }else{
            if(fp == null){
                xml_buff = xml_buff + xml_block+"\n";
            }else{
                fwrite(fp,xml_block+"\n");
            }
        }
        if(flg == 1){
            sql = "select value from "+table+" where type="+DTD_TYPE+" order by pos";
            rs = do_query(sql,"write_document");
            String dtd_block = "";
            while(rs.next()){
                String tmp = rs.getString(1);
				tmp = xml64.text_decode(tmp,enc);
                if(tmp != null){
                    dtd_block = dtd_block + tmp.trim() + "\n";
                }
            }
            sql = "select name,value from "+table+" where type="+PI_TYPE+" order by pos";
            rs = do_query(sql,"write_document");
            String pi_block="";
            while(rs.next()){
                String target = rs.getString(1);
				target = xml64.text_decode(target,enc);
                if(target != null){
                    target = target.trim();
                }else{
                    target = "";
                }
                String data = rs.getString(2);
				data = xml64.text_decode(data,enc);
                if(data != null){
                    data.trim();
                }else{
                    data = "";
                }
                pi_block = pi_block + "<?"+target+"\n\t"+data+"\n?>\n";
            }
            if(fp == null){
                xml_buff = xml_buff + dtd_block;
                xml_buff = xml_buff + pi_block;
            }else{
                fwrite(fp,dtd_block);
                fwrite(fp,pi_block);
            }
        }
        sql = "select value from "+table+" where type="+COMMENT_TYPE+" and parent=0 order by pos";
        rs = do_query(sql,"write_document");
        String comment_block = "";
        while(rs.next()){
            String tmp = rs.getString(1);
			tmp = xml64.text_decode(tmp,enc);
            if(tmp != null){
                comment_block = comment_block + tmp.trim() + "\n";
            }
        }
        if(fp == null){
            xml_buff = xml_buff + comment_block;
        }else{
            fwrite(fp,comment_block);
        }
        int id = get_doc_root();
        write_node(id,fp,0);
        rs.close();
    }
    public void fwrite(FileWriter fw,String text) throws Exception{
        fw.write(text,0,text.length());
    }
    public void press() throws Exception{
        String sql = "select id from "+table+" where type="+ELEMENT_TYPE+" for update";
        ResultSet rs = do_query(sql,"press");
		int i=0;
		int id=0;
        while(rs.next()){
            id = rs.getInt(1);
			idArray.set_int(i++,id);
		}
        rs.close();
		for(int j=0;j<i;j++){
			id = idArray.get_int(j);
            sql = "select id,value from "+table+" where parent="+id+" and type="+TEXT_TYPE;
            ResultSet rs2 = do_query(sql,"press");
            String text = "";
            while(rs2.next()){
                int text_id = rs2.getInt(1);
                text = text + rs2.getString(2).trim() + "\n";
            }
            rs2.close();
            text = text.trim();
            sql = "update "+table+" set value='"+text+"' where id="+id;
            do_query(sql,"press");
        }
        sql = "delete from "+table+" where type="+TEXT_TYPE;
        do_query(sql,"press");
    }
    public void die(String text) throws Exception{
//        text = new String(text.getBytes(),"UTF-8");
        throw new Exception(text);
    }
    public String replace(String pat,String chg,String text){
        int begin = 0;
        int pos = text.indexOf(pat);
        int len = pat.length();
        String sub = "";
        while(pos != -1){
            String sub2 = text.substring(begin,pos);
            sub = sub + sub2 + chg;
            begin = pos + len;
            pos = text.indexOf(pat,begin);
        }
        sub = sub + text.substring(begin);
        return sub;
    }
    public String addslashes(String text){
        text = replace("\\","\\\\",text);
        text = replace("\'","\\\'",text);
        text = replace("\"","\\\"",text);
        return text;
    }
    public String stripslashes(String text){
        text = replace("\\\"","\"",text);
        text = replace("\\\'","\'",text);
        text = replace("\\\\","\\",text);
       return text;
    }
	public void get_encode(String xml)throws Exception{
		xml = stripslashes(xml);
		int pos = xml.indexOf("encoding");
		if(pos == -1){
			enc = "ISO-8859-1";
		}else{
			enc = xml.substring(pos+10);
			enc = enc.replaceAll("\'","\"");
			pos = enc.indexOf("\"");
			enc = enc.substring(0,pos);
			if(enc.toUpperCase().equals("SHIFT_JIS")||enc.toUpperCase().equals("SHIFT__JIS")){
				enc = "SJIS";
			}
		}
	}
	public String get_xml_buff(){
		return xml_buff;
	}

}

